## Script (Python) "portlets_garage.py"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Helper methods
##
#    CMFPortlets 0.5
#    Portlets for the CMF. Initial preview release, October 18th, 2002. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')
REQUEST = context.REQUEST



#add page

if REQUEST.has_key('add') and REQUEST.add == 'page':

    temp = ps
    for k,v in temp:
        new_page = "p%s" % (int(k[1:]) + 1)
       
    pcolumn = [['column1', [], {'col_width': '0' }], ['column2', [], {'col_width': '0'}] ]

    temp.append([new_page, {'pcolums': pcolumn, 'ptitle': 'Untitled page', 'pwidth':'100%', 
                          'palign':'center', 'pcellpad':'3', 'pcellspace':'0',  
                           'pstylesheet_fixed':[], 'pstylesheet_dyn':[]}])
    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)
    return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + new_page)


elif REQUEST.has_key('add') and REQUEST.add == 'row':
    return "Not implemented"


# add column

elif REQUEST.has_key('add') and REQUEST.add == 'column':
    p = REQUEST.p
    temp = ps
    for x in range(len(ps)):
        if ps[x][0] == p:
            pcolumn = temp[x][1]['pcolums']
            if len(pcolumn) < 14:
                pcolumn.append(['column1', [], {'col_width': '0' }])
            else:
                return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )
     
    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)
    return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )



#add content

elif REQUEST.has_key('add_content') and REQUEST.add_content == ' Add ':
    p = REQUEST.p
    col = int(REQUEST.col) - 1
    temp = ps
    if REQUEST.portlet == 'Add a section box':
        return None
    portlet= REQUEST.portlet.split('@@') #retrieve the list. Assumes the value has a @@ string. Maybe we need to handle other possibilities.
    #return portlet
    portlet_skin = REQUEST.portlet_skin
    if portlet_skin == '':
        portlet_skin = 'default'

    portlet_id = portlet[0]

    portlet_url = portlet[1]

    for x in range(len(ps)):
        if ps[x][0] == p:          #ps[x][0] es p1 o p2 etc
            column_content = temp[x][1]['pcolums'][col][1]
            #column_content.insert(0, portlet)
            column_content.append([portlet_id,portlet_url,{'box_skin':portlet_skin}])

    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)

    return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )




# delete page


elif REQUEST.has_key('delete') and REQUEST.delete == 'page':

    if REQUEST.has_key('col'): col = int(REQUEST.col)
    else: col = 3
    if REQUEST.has_key('p') and REQUEST.p != 'p1':
        ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')
        temp = ps
        for k in ps:
            if k[0] == REQUEST.p:
                page_pos = ps.index(k)
                try:target_page = ps[page_pos + 1][0]
                except: target_page = ps[page_pos - 1][0]
                temp.remove(k)
                context.portal_membership.getAuthenticatedMember().setProperties(personal_selections = temp)
                break            
        return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + target_page )



# delete column

elif REQUEST.has_key('delete') and REQUEST.delete == 'column':

    p = REQUEST.p
    col = int(REQUEST.col)-1


    temp = ps
    for x in range(len(ps)):
        if ps[x][0] == p:
            pcolumn = temp[x][1]['pcolums']
            #print col
            #print pcolumn[col]
            #return printed
            pcolumn.remove(pcolumn[col])        

    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)

    return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )


# delete content

elif REQUEST.has_key('delete') and REQUEST.delete == 'content':
    p = REQUEST.p
    col = int(REQUEST.col)- 1
    temp = ps
    box = REQUEST.box

    for x in range(len(ps)):
        if ps[x][0] == p:
            column_content = temp[x][1]['pcolums'][col][1]
            for item in column_content:     #new starting here
                if item[0]== box:
                    column_content.remove(item) #new end here
            context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)
            return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )


# rename page

elif REQUEST.has_key('rename') and REQUEST.rename == 'page':
    if REQUEST.has_key('col'): col = int(REQUEST.col)
    else: col = 3

    if REQUEST.has_key('p') :
        p = REQUEST.p
        if REQUEST.has_key('ntitle') and REQUEST.ntitle is not None:
            ntitle = REQUEST.ntitle 
        else:
            print """
    <html><body>
    <form name="form1" method="post" action="%s">
      Nuevo nombre: 
      <input type="text" name="ntitle" value=''>
      <input type="hidden" name="p" value="%s">
      <input type="hidden" name="rename" value="page">
      <input type="submit" name="Submit" value="Submit">
      
    </form>
    </body></html>"""  % (context.absolute_url()+ '/portlets_garage', p )
            return printed    
        
        #ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')
        temp = ps
        for k in temp:
            if k[0] == p:
                k[1]['ptitle']= ntitle
                context.portal_membership.getAuthenticatedMember().setProperties(personal_selections = temp)
                break
            f = k[0]
        return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )



elif REQUEST.has_key('getnew_boxskin') and REQUEST.getnew_boxskin == 'Change':
    p = REQUEST.p
    col = int(REQUEST.col)- 1
    temp = ps
    box = REQUEST.box
    box_skin = REQUEST.box_skin
    portlet_skin = REQUEST.portlet_skin
    if portlet_skin == '':
        portlet_skin = 'default'

    for x in range(len(ps)):
        if ps[x][0] == p:
            column_content = temp[x][1]['pcolums'][col][1]
            for item in column_content:     #new starting here
                if item[0]== box:
                    item[2]['box_skin'] = portlet_skin
            context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)
            return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )



elif REQUEST.has_key('new_width') and REQUEST.new_width == 'Change width':
    p = REQUEST.p
    col = int(REQUEST.col)-1
    new_col_width = REQUEST.ncolw
    if new_col_width == '':
        return None


    temp = ps
    for x in range(len(ps)):
        if ps[x][0] == p:
            pcolumn = temp[x][1]['pcolums']
            pcolumn[col][2]['col_width'] = new_col_width      

    context.portal_membership.getAuthenticatedMember().setProperties(personal_selections=temp)
    return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )
        
        
elif REQUEST.has_key('change_pagetable') and REQUEST.change_pagetable == 'Change':

    REQUEST = context.REQUEST
    if REQUEST.has_key('col'): col = int(REQUEST.col)
    else: col = 3

    new_page_cellpad = REQUEST.npage_cellpad
    if new_page_cellpad == '':
        new_page_cellpad = '3'    
    new_page_cellspace = REQUEST.npage_cellspace
    if new_page_cellspace == '':
        new_page_cellspace = '0'
    new_page_width = REQUEST.npagew
    if new_page_width == '':
        new_page_width = '100%'
    new_page_align = REQUEST.npalign
    if new_page_align == '':
        new_page_align = 'center'
        
    if REQUEST.has_key('p'):
        p = REQUEST.p
        ps = context.portal_membership.getAuthenticatedMember().getProperty('personal_selections')
        temp = ps
        for k in ps:
            if k[0] == REQUEST.p:
                k[1]['pwidth']= new_page_width
                k[1]['palign']= new_page_align
                k[1]['pcellpad']= new_page_cellpad
                k[1]['pcellspace']= new_page_cellspace
                #temp.remove(k)
                context.portal_membership.getAuthenticatedMember().setProperties(personal_selections = temp)
                break
            #f = k[0]
        return REQUEST.RESPONSE.redirect(context.absolute_url()+ '/page_view?p=' + p )

else:
    return "Oops!. What told you could come into this method in the first place, huh?  ;)"
