## Script (Python) "portlets_BoxBuilder.py"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=box_title, box_content, p, col, box, use_table=None, box_skin=None, edit_url=None, vmo=None
##title=The boxes' skins repository (at code level)
##
#    CMFPortlets 0.5
#    Portlets for the CMF. Initial preview release, October 18th, 2002. 
#    Copyright (c) Augusto Cabrera. All rights reserved. GPL licensed with exceptions. Read LICENSE.txt


def cooked_content(bcontent, utable=1):
    if utable == 1:  #we need a table surrounding the content
        content = "<table cellpadding=4><tr><td>%s</td></tr></table>" % (bcontent)
        return content
    else:
        return bcontent


if edit_url != 0:
    edit_icon = """<TD height="18" valign="middle"><A href="%s"><IMG src="icon_edit.gif"
                 border=0 align="middle"></A></TD>""" % (edit_url)
else:
    edit_icon = ''
delete_url = "portlets_garage?delete=content&p=%s&col=%s&box=%s" % (p,col,box)
remove_icon="<a href=portlets_garage?delete=content&p=%s&col=%s&box=%s  ><img src='icon_remove.gif' border='0' ></a>" % (p,col,box)

if box_skin in ['default','type1','type2']:
    color_table = {'default':'#336699', 'type1':'#E4072E', 'type2':'#959500'}
    bgcolor = color_table[box_skin]
    useTable = 1
    thebox = """<TABLE cellSpacing=0 cellPadding=1 width="100%%" bgColor=#cccccc border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%"
border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%" border=0><TR valign="middle" bgColor=%s ><TD width=10 height="18"><IMG height=18
src="spacer.gif" width=10></TD><TD width="100%%" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#ffffff"><B>%s</B></font>
</TD>%s<TD width=10 height="18">%s</TD></TR></TABLE></TD></TR><TR vAlign=top bgColor=#ffffff nowrap><TD align=top>%s</TD></TR></TABLE></TD></TR></TABLE>
""" % (bgcolor, box_title, edit_icon, remove_icon, cooked_content(box_content, useTable) )
    return thebox

elif box_skin == 'noskin':
    if vmo == '1':
        thebox = """<table width=100%%><tr><td><a href="%s">delete</a></td></tr><tr><td>%s</td></tr></table>""" % (delete_url, box_content)
        return thebox
    else:
        return box_content
    
else:
    bgcolor = '#336699'
    useTable = 1
    thebox = """<TABLE cellSpacing=0 cellPadding=1 width="100%%" bgColor=#cccccc border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%"
border=0><TR><TD><TABLE cellSpacing=0 cellPadding=0 width="100%%" border=0><TR valign="middle" bgColor=%s ><TD width=10 height="18"><IMG height=18
src="spacer.gif" width=10></TD><TD width="100%%" height="18"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#ffffff"><B>%s</B></font>
</TD>%s<TD width=10 height="18">%s</TD></TR></TABLE></TD></TR><TR vAlign=top bgColor=#ffffff nowrap><TD align=top>%s</TD></TR></TABLE></TD></TR></TABLE>
""" % (bgcolor, box_title, edit_icon, remove_icon, cooked_content(box_content, useTable) )
    return thebox
